
#include <stdafx.h>

#include <stdio.h>

#include "resource.h"


#include "os.h"
#include "wimp.h"
#include "font.h"
#include "bbc.h"


#include "wos.h"
#include "poll.h"
#include "temp.h"
#include "pane.h"
#include "etc.h"
#include "redraw.h"
#include "colour.h"
#include "fsx.h"
#include "bf.h"
#include "comdialogs.h"
#include "comctls.h"
#include "deb.h"
#include "osunits.h"


#include "reslink.h"
#include "mainwin.h"
#include "soln.h"
#include "grid.h"
#include "memblock.h"
#include "dc.h"
#include "edit.h"
#include "main.h"
#include "xstdio.h"

#include "cxchoices.h"




os_error * setchoicesparameters(void)
{
 font_metric metric;


 font_getmetric_description(&solnfont,&metric);
 solnleading=ypix2os(metric.ascent);
 solnintheight=ypix2os(metric.height);
 solnextheight=ypix2os(metric.height+metric.extleading);
 font_getwidths_description(&solnfont,&solncharwidth);
 solncharwidth=xpix2os(solncharwidth);
 solncharwidth++;

 font_getmetric_description(&editfont,&metric);
 editleading=ypix2os(metric.ascent);
 editheight=ypix2os(metric.height+metric.extleading);
 editwidth=xpix2os(metric.averagewidth*STRLEN);

 return(NULL);
}




static os_error * savechoices(void)
{
 os_error * err;
 char       uname[MAX_USERNAME];
 char       name[MAX_PATH];
 FILE     * fp;

 err=getusername(uname,sizeof(uname));
 if(!err)
 {
  sprintf(name,"%sChoices\\%s.dat",programdir,uname);

  fp=fopenex(name,"wb");
  if(fp)
  {
   fwrite(&editfont,sizeof(font_description),1,fp);
   fwrite(&solnfont,sizeof(font_description),1,fp);
   fwrite(&cursorcolour,sizeof(int),1,fp);
   fwrite(&zonecolour,sizeof(int),1,fp);
   fwrite(&splitfraction,sizeof(int),1,fp);
   fwrite(&solnmaxn,sizeof(int),1,fp);
   fclose(fp);
  }
 }

 return(err);
}




os_error * loadchoices(void)
{
 os_error * err;
 char       uname[MAX_USERNAME];
 char       name[MAX_PATH];
 int        type;
 FILE     * fp;

 editfont=defeditfont;
 solnfont=defsolnfont;

 err=getusername(uname,sizeof(uname));
 if(!err)
 {
  sprintf(name,"%sChoices\\%s.dat",programdir,uname);
  fs_exists(name,&type);
  if(type==1)
  {
   fp=fopenex(name,"rb");
   if(fp)
   {
    fread(&editfont,sizeof(font_description),1,fp);
    fread(&solnfont,sizeof(font_description),1,fp);
    fread(&cursorcolour,sizeof(int),1,fp);
    fread(&zonecolour,sizeof(int),1,fp);
    fread(&splitfraction,sizeof(int),1,fp);
    fread(&solnmaxn,sizeof(int),1,fp);
    fclose(fp);
   }
  }
 }

 setchoicesparameters();

 return(NULL);
}










static int choiceshandle;

static int xcursorcolour;
static int xzonecolour;

static font_description xeditfont;
static font_description xsolnfont;

static int xsolnmaxn;


static os_error * choicesicon(int handle,int userhandle,wimp_mousestr * m);




static os_error * redrawsample(wimp_redrawstr * r,int handle,int icon,font_description * fd,int rgbpal,int backcol)
{
 os_error  * err;
 int         fh;
 int         bx;
 int         by;
 iconstr     ic;
 font_metric metric;
 int         shift;

 err=font_find_description(fd,&fh);
 if(!err)
 {
           err=font_setcolour(fh,PALTRANSPARENT,rgbpal,0);
  if(!err) err=font_align(FA_LEFT|FA_BASELINE);
  if(!err) err=font_getmetric(&metric);

  if(!err) err=geti(handle,icon,&ic);
  if(!err)
  {
   bx=r->box.x0-r->scx;
   by=r->box.y1-r->scy;

            err=setgcol(backcol);
   if(!err) err=bbc_rectanglefill(bx+ic.ix0,by+ic.iy1,ic.ix1-ic.ix0,ic.iy0-ic.iy1);
   if(!err) err=bbc_gwindow(bx+ic.ix0,by+ic.iy0,bx+ic.ix1,by+ic.iy1);
   if(!err)
   {
    shift=ic.iy1-ypix2os(metric.ascent)-((ic.iy1-ic.iy0)-ypix2os(metric.height))/2;
    err=font_paint("ABCabc123",font_ABS|font_OSCOORDS|font_BACKBLEND,bx+ic.ix0,by+shift);
    bbc_gwindowrelease();
   }
  }
  font_lose(fh);
 }

 return(err);
}





static os_error * choicesredrawsub(int handle,wimp_redrawstr * redrawstr,int more)
{
 os_error * err;

 err=NULL;

 while(more)
 {
  redrawblock(redrawstr,handle,IDC_CHOICES_CURSOR,xcursorcolour);
  redrawblock(redrawstr,handle,IDC_CHOICES_ZONE,xzonecolour);
  redrawsample(redrawstr,handle,IDC_CHOICES_DICTFONT,&xeditfont,0,0xFFFFFF00);
  redrawsample(redrawstr,handle,IDC_CHOICES_SOLNFONT,&xsolnfont,0,0xFFFFFF00);

  err=wimp_get_rectangle(redrawstr,&more);
 }
 return(err);
}



static os_error * choicesredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;
 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) err=choicesredrawsub(handle,&redrawstr,more);
 return(err);
 USE(userhandle);
}




static os_error * choicesclose(int w,int ok)
{
 os_error * err;
 char     * p;

 err=NULL;

 err=iconaddr(choiceshandle,IDC_CHOICES_SOLN,&p);
 sscanf(p,"%d",&xsolnmaxn);
 if(xsolnmaxn<20) xsolnmaxn=20;
 if(xsolnmaxn>1000000) xsolnmaxn=1000000;

 if(ok)
 {
  cursorcolour=xcursorcolour;
  zonecolour=xzonecolour;
  editfont=xeditfont;
  solnfont=xsolnfont;
  solnmaxn=xsolnmaxn;
  setchoicesparameters();
  updatesolutions();
  updateedit();
  updatecheck();
  refreshgrid();
  if(ok==2) err=savechoices();
 }

 if(!err)
 {
  enablewindow(mainhandle,1,0);
  
  remclickevent(choicesicon,choiceshandle,0);
  remcloseevent(choicesclose,choiceshandle,0);
  remredrawevent(choicesredraw,choiceshandle,0);

  err=closedown(&choiceshandle);
 }


 return(err);

 USE(w);
}







static os_error * choicesicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 int        result;


 err=NULL;

 switch(m->i)
 {
  case IDC_CHOICES_CURSORR:
  case IDC_CHOICES_CURSOR:
                         err=cd_getcolour(handle,0,&xcursorcolour,&result);
                         if(result) repainticon(handle,IDC_CHOICES_CURSOR);
                         break;

 case   IDC_CHOICES_ZONER:
  case   IDC_CHOICES_ZONE:
                         err=cd_getcolour(handle,0,&xzonecolour,&result);
                         if(result) repainticon(handle,IDC_CHOICES_ZONE);
                         break;

 case  IDC_CHOICES_DICTFONTR:                         
 case  IDC_CHOICES_DICTFONT:
                         err=cd_getfont(handle,0,&xeditfont,&result);
                         if(result) repainticon(handle,IDC_CHOICES_DICTFONT);
                         break;

 case  IDC_CHOICES_SOLNFONTR:
 case  IDC_CHOICES_SOLNFONT:
                         err=cd_getfont(handle,0,&xsolnfont,&result);
                         if(result) repainticon(handle,IDC_CHOICES_SOLNFONT);
                         break;

 case   IDC_CHOICES_SAVE:
                         err=choicesclose(handle,2);
                         break;
 
               case IDOK:
                         err=choicesclose(handle,1);
                         break;

           case IDCANCEL:
                         err=choicesclose(handle,0);
                         break;

 }

 return(err);

 USE(userhandle);
}






os_error * cxchoices(int parent)
{
 os_error * err;

 if(choiceshandle) err=forward(choiceshandle,0,NULL);
 else
 {
  err=createwindowparent(TCHOICES,&choiceshandle,parent);

  if(!err)
  {
   xcursorcolour=cursorcolour;
   xzonecolour=zonecolour;
   xeditfont=editfont;
   xsolnfont=solnfont;
   xsolnmaxn=solnmaxn;

   addclickevent(choicesicon,choiceshandle,0);
   addcloseevent(choicesclose,choiceshandle,0);
   addredrawevent(choicesredraw,choiceshandle,0);

   cc_spinrange(choiceshandle,IDC_CHOICES_SOLNSPIN,20,1000000);
   writeiconf(choiceshandle,IDC_CHOICES_SOLN,"%d",xsolnmaxn);

   popup(choiceshandle,0);

   iecarrot(choiceshandle,IDC_CHOICES_SOLN);

   enablewindow(mainhandle,0,0);
  }
 }

 return(err);
}


