/*->c.reslink */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "font.h"


#include "mlo.h"
#include "transform.h"
#include "poll.h"

#include "err.h"
#include "temp.h"
#include "filetype.h"
#include "bf.h"


#include "constants.h"

#include "mainwin.h"
#include "memblock.h"
#include "dc.h"
#include "spell.h"
#include "edit.h"
#include "reslink.h"



static errtag errortable[]=
{
 ENOTTYPE,"{ENOTTYPE}",
 EREPDEC,"{EREPDEC}",
 EREPNEG,"{EREPNEG}",
 EBADVAL,"{EBADVAL}",

 EBU,"{EBU}",
 EBD,"{EBD}",
 EBB,"{EBB}",
 EID,"{EID}",
 EPCD,"{EPCD}",
 EPCL,"{EPCL}", 
 ECR,"{ECR}",


 EBADBITS,"{EBADBITS}",

 EC00,"{EC00}",
 EC01,"{EC01}",
 EC02,"{EC02}",


 EVM00,"{EVM00}",

 ES00,"{ES00}",

 EMODE,"{EMODE}",

 ED00,"{ED00}",

 EICO0,"{EICO0}",

 ENMW,"{ENMW}",
 ENTS,"{ENTS}",
 EASW,"{EASW}",
 EMDC,"{EMDC}",
 ENUD,"{ENUD}",
 EDAX,"{EDAX}",
 ENOD,"{ENOD}",
 EASP,"{EASP}",
 EDCOLD,"{EDCOLD}",
 EDCAPS,"{EDCAPS}",
 EAMAT,"{EAMAT}",
 ENOSAVE,"{ENOSAVE}",

 ELAST ,""
};


static errlink errorlink;

static templates temptable[]=
{
 TCONF,1,0,"Confirm",
 TINFO,1,0,"Info",
 TMAIN,0,0,"main",
 TSOLN,0,0,"solutions",
 TGRID,0,0,"grid",
 TGRIDSIZE,0,0,"gridsize",
 TNEWDICT,0,0,"newdict",
 TEDIT,0,0,"edit",
 TCHECK,0,0,"check",
 TPANE,0,0,"pane",
 TBUTTONS,0,0,"buttons",
 TCUSTOM,0,0,"custom",
 TCHOICES,0,0,"choices",
 TBUTTONS1,0,0,"buttons1",
 TBUTTONSW,0,0,"buttons2",
 TCUSTOMW,0,0,"customw",


 TLAST,0,0,""
};


static templink templatelink;

/*
typedef struct menustr
{
 int            menuno;
 char         * menuname;
 int          * menuptr;
 int            flags;
 int            parent;
 int            entryinparent;
 menudecodefn   decode;
 menudynamicfn  dynamic;
} menustr;

*/




static menustr menutable[]=
{
 MMAIN,  "Main",    NULL,  0,  0,  0,         0,              0, maindecode,maindynamic,
 MFILE,   NULL,     NULL,  0,  0,  MMAIN,     FILE_M_MAIN,    0, NULL,      NULL,
 MWORDS,  NULL,     NULL,  0,  0,  MMAIN,     WORDS_M_MAIN,   0, NULL,      NULL,
 MGRID,   NULL,     NULL,  0,  0,  MMAIN,     GRID_M_MAIN,    0, NULL,      NULL,
 MHELP,   NULL,     NULL,  0,  0,  MMAIN,     HELP_M_MAIN,    0, NULL,      NULL,
 MREFLECT,NULL,     NULL,  0,  0,  MGRID,     REFLECT_M_GRID, 0, NULL,      NULL,
 MUSERF,  NULL,     NULL,  0,  0,  0,         0,              0, NULL,      NULL,
 MDICTBASE,"Dict",  NULL,  0,  0,  0,         0,              0, NULL,      NULL,
 MDICT,   NULL,     NULL,  0,  0,  MDICTBASE, 0,              0, editdictdecode,NULL,
 MTYPE,   NULL,     NULL,  0,  0,  MGRID,     TYPE_M_GRID,    0, NULL,      NULL,

 MLAST,   NULL,     NULL,  0,  0,  0,         0,              0, NULL,      NULL,

};


static menulink mlink;





static filetypelink filetypelink;


static filetypetag filetypetable[]=
{
 CXFTYPE,"crx","CrossStar grid (*.crx)",
 TEXTFILE,"txt","Text (*.txt)",
 DATA,NULL,"Data (*.dat)",
 EMFTYPE,"emf","Enhanced metafile (*.emf)",
 WMFTYPE,"wmf","Windows metafile (*.wmf)",
 PMFTYPE,"wmf","Placement metafile (*.wmf)",
 FTDEFLT,"dat","Data (*.dat)",

 FTLAST,NULL,NULL,
};





os_error * resinit(char * resources)
{
 os_error * err;

          err=adderrortable(errortable,&errorlink);
 if(!err) err=addtemplates(resources,"Templates",temptable,&templatelink);
 if(!err) err=addmenus(NULL,NULL,menutable,&mlink);
 if(!err) err=addfiletypetable(filetypetable,&filetypelink);

 return(err);
}

