// soln.cpp
//

#include "stdafx.h"
#include "resource.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "etc.h"


#include "os.h"
#include "wimp.h"
#include "bbc.h"
#include "akbd.h"
#include "flex.h"
#include "font.h"

#include "deb.h"

#include "key.h"
#include "wos.h"
#include "bf.h"
#include "err.h"
#include "colour.h"
#include "temp.h"
#include "poll.h"
#include "bits.h"
#include "hourglass.h"


#include "main.h"
#include "memblock.h"
#include "dc.h"
#include "spell.h"
#include "mainwin.h"
#include "reslink.h"
#include "file.h"
#include "mainwin.h"

#include "soln.h"

#include "grid.h"


cluestruct cluestr[MAXCLUE];      /* big list of things to solve */

int cluex0;
int cluex1;
int cluey0;
int cluey1;



char * sbuffer;   



static void writesolution(int s);







/*****************************************************************************/

static os_error * newredraws(wimp_redrawstr * redrawstr)
{
 os_error * err;
 int      bx;
 int      by;
 int      w;
 int      h;
 char   * dbuffer;
 int      i;
 int      j;
 int      gy1;
 char   * p;
 char   * q;
 char   * r;
 int      y;
 char     string[256];
 int      zx;
 int      zy;
 int      n;
 int      cx;
 int      cy;
 int      c;
 int      ntabs;
 int      tabs[STRLEN];
 int      deskfonthandle;


 err=font_find_description(&solnfont,&deskfonthandle);
 if(!err)
 {
  font_setfont(deskfonthandle);
  font_align(FA_CENTRE|FA_BASELINE);


  bx=redrawstr->box.x0-redrawstr->scx;
  by=redrawstr->box.y1-redrawstr->scy;

  w=cluex1-cluex0+1;
  h=cluey0-cluey1+1;

  err=flex_alloc((flex_ptr)&dbuffer,w*h);
  if(!err)
  {
   p=dbuffer;

   if(solwidth<=1 && h>1)
   {
    w=h;
    h=1;
   }

   gy1=((redrawstr->g.y1-by)/solheight)*solheight+by;

   j=(-(gy1-by))/solheight;

//     cprintf("j=%d",j);


   for(y=gy1;y>=(redrawstr->g.y0-solheight) && j<nsol;j++,y-=solheight)    
   {
    memset(p,0,w*h);

    for(i=0;i<solwidth;i++)
    {
     q=p+(cluestr[i].x-cluex0)+w*(cluestr[i].y-cluey1);
     r=swordn(*((int*)(sbuffer+(j*solwidth+i)*sizeof(int))));

     if(cluestr[i].down && (solwidth>1)) 
     {
      while(*r)
      {
       *q=(char)gridcasechar(*r++);
       q+=w;
      }
     }
     else
     {
      while(*r)
      {
       *q++=(char)gridcasechar(*r++);
      }
     }
    }


    for(zy=0;zy<h;zy++)
    {
     n=0;
     ntabs=0;

     for(zx=0;zx<w;zx++)
     {
      c=*(p+zy*w+zx);
      if(c && c!=32)
      {
       string[n++]='\t';
       string[n++]=(char)c;
     	 tabs[ntabs++]=solncharwidth*zx+solncharwidth/2;
      }
     }
     string[n]=0;

     cx=bx+HORIZMARGIN+HORIZSHIFT;
     cy=y-VERTMARGIN-VERTSHIFT-zy*solnintheight;

//     cprintf("paint cy %d cx %d %s",cy,cx,string);

     font_painttabbed(string,font_ABS|font_OSCOORDS|font_BACKBLEND,cx,cy-solnleading,ntabs,tabs,cx);
    }
   }
   flex_free((flex_ptr)&dbuffer);
  }

  font_lose(deskfonthandle);
 }
 return(err);
}





/* redraw just single clues */

static os_error * sxredraw(wimp_redrawstr * redrawstr)
{
 os_error  * err;
 int         bx;
 int         by;
 int         gy1;
 int         y;
 int         j;
 char      * p;
 char      * q;
 int         cx;
 int         cy;
 int         shift;
 char        temp[STRLEN];
 int         deskfonthandle;
 wrdstr    * w;



 err=font_find_description(&solnfont,&deskfonthandle);
 if(!err)
 {
  err=font_setcolour(deskfonthandle,PALWHITE,PALBLACK,0);
  err=font_align(FA_LEFT|FA_BASELINE);

  shift=solheight-solnintheight;
  shift/=2;
  shift+=solnleading;


  bx=redrawstr->box.x0-redrawstr->scx;
  by=redrawstr->box.y1-redrawstr->scy;

  gy1=((redrawstr->g.y1-by)/solheight)*solheight+by;

  j=(-(gy1-by))/solheight;


  for(y=gy1;y>=(redrawstr->g.y0-solheight) && j<nsol;j++,y-=solheight)    
  {
   cx=bx+HORIZMARGIN+HORIZSHIFT;//+(cluestr[0].x-zx0)*CHWIDTH;
   cy=y-VERTMARGIN;//-/*VERTSHIFT- */(cluestr[0].y-zy1)*CHHEIGHT;


   if(gridtype==SQUARETYPE)
   {
    w=(wrdstr*)(sbuffer+j*sizeof(wrdstr));

    if(w->selected)
    {
     setgcol(PALBLACK);
     bbc_rectanglefill(cx,cy,solxwidth-2*HORIZMARGIN,-solheight);

     setgcol(PALWHITE);
     err=font_setcolour(deskfonthandle,PALTRANSPARENT,PALWHITE,0);
    }

    p=w->text;
    q=temp;
    do
    {
     *q++=(char)gridcasechar(*p++);
    } while(*(p-1)!=0);

    font_paint(temp,font_ABS|font_OSCOORDS|font_BACKBLEND,cx,cy-shift);

    if(w->selected)
    {
     err=font_setcolour(deskfonthandle,PALWHITE,PALBLACK,0);
    }
   }
   else
   {
    p=swordn(*((int*)(sbuffer+(j*solwidth)*sizeof(int))));
    q=temp;
    do
    {
     *q++=(char)gridcasechar(*p++);
    } while(*(p-1)!=0);

    font_paint(temp,font_ABS|font_OSCOORDS|font_BACKBLEND,cx,cy-shift);
   }
  }

  font_lose(deskfonthandle);
 }
 return(err);
}






void refreshsols(void)
{
 refreshwindow(solnhandle);
}



static os_error * solnredrawsub(wimp_redrawstr * redrawstr,int more)
{
 os_error * err;

 err=NULL;
 
 if(solwidth>1)
 {
  while(more)
  { 
   err=newredraws(redrawstr);
   wimp_get_rectangle(redrawstr,&more);
  }
 }
 else
 {
  while(more)
  { 
   err=sxredraw(redrawstr);
   wimp_get_rectangle(redrawstr,&more);
  }
 }

 return(err);
}



static os_error * solnredraw(int handle,int userhandle)
{
 os_error       * err;
 wimp_redrawstr   redrawstr;
 int              more;

 redrawstr.w=handle;

          err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) err=solnredrawsub(&redrawstr,more);

 return(err);
 USE(userhandle);
}






os_error * setsolextent(void)
{
 return(extent(solnhandle,0,-(nsol*solheight),solxwidth,0));
}



void opensol(void)
{
 windowstr window;


 getw(solnhandle,&window);
 if(window.wflags & 0x10000) openatscroll(solnhandle,0,0);
}






os_error * squaresolnclick(int handle,int userhandle,wimp_mousestr * m)
{
 int         x;
 int         y;
 wrdstr    * w;
 windowstr   window;
 int         ctrl;

 getw(handle,&window);
 x=(m->x-window.x0+window.scx)/CHWIDTH;
 y=(-window.scy+window.y1-m->y-VERTMARGIN)/solheight;


 kill_cursor();
 removecursor();

 ctrl=isctrl;

 gridstartredraw();

 if(m->bbits==4 && !ctrl)    /* select */
 {
  if(y<nsol && y>=0) 
  {
   w=(wrdstr*)(sbuffer+y*sizeof(wrdstr));
   if(!w->selected || nselectedsquare()>1)
   {
    clearselection();
    w->selected=1;
    gridsetword(w);
    calczonesize();
    gridaddredraw(w);
    refreshsols();
   }
  }
 }
 else
 if(m->bbits==1 || (ctrl && m->bbits==4))
 {
  if(y<nsol && y>=0) 
  {
   w=(wrdstr*)(sbuffer+y*sizeof(wrdstr));
   w->selected^=1;
   if(w->selected) gridsetword(w);
   else            gridclrword(w);
   calczonesize();
   gridaddredraw(w);
   refreshsols();
  }
 }

 gridendredraw();

 return(NULL);

 USE(userhandle);
}






static os_error * crosssolnclick(int handle,int userhandle,wimp_mousestr * m)
{
 int       x;
 int       y;
 windowstr window;

 getw(handle,&window);
 x=(m->x-window.x0+window.scx)/CHWIDTH;
 y=(-window.scy+window.y1-m->y-VERTMARGIN)/solheight;

 if(m->bbits==4 && zx0!=-1)
 {
  if(y<nsol)
  {
   writesolution(y);
   refresh_zone();
  }
 }

 return(NULL);

 USE(userhandle);
}




static os_error * solnclick(int handle,int userhandle,wimp_mousestr * m)
{
 if(gridtype==CROSSTYPE) return(crosssolnclick(handle,userhandle,m));
 else                    return(squaresolnclick(handle,userhandle,m));
}




/**************************************************************************/


#define SCHUNK 0x800


void clearsolutions(void)
{
 flex_free((flex_ptr)&sbuffer);
 nsol=0;
 buttonssoln(nsol);
}


os_error * addsolution(int dcdata,int word)
{
 os_error * err;

 err=NULL;


 if(word==(solwidth-1))   /* starting a new solution */
 {
  if(!sbuffer) err=flex_alloc((flex_ptr)&sbuffer,SCHUNK);
  else         err=flex_chunk((flex_ptr)&sbuffer,(nsol+1)*sizeof(int)*solwidth,SCHUNK);
  
  if(!err)
  {
   nsol++;
   buttonssoln(nsol);
  }
 }

 if(sbuffer)
 {
  *((int*)(sbuffer+((nsol-1)*solwidth+word)*sizeof(int)))=dcdata;
 }

 return(err);
}



os_error * addsquaresolution(int x,int y,int dx,int dy,char * string)
{
 os_error * err;
 wrdstr   * w;

 if(!sbuffer) err=flex_alloc((flex_ptr)&sbuffer,SCHUNK);
 else         err=flex_chunk((flex_ptr)&sbuffer,(nsol+1)*sizeof(wrdstr),SCHUNK);

 if(!err)
 {
  nsol++;
  buttonssoln(nsol);

  w=(wrdstr*)(sbuffer+(nsol-1)*sizeof(wrdstr));

  w->x=x;
  w->y=y;
  w->dx=dx;
  w->dy=dy;
  w->selected=0;
  strcpy(w->text,string);
 }

 return(err);
}




char savestring[STRLEN+1];

void saveswop(void)
{
 char temp[STRLEN+1];
// strcpy(temp,iconaddr(whandle[CROSS],5));
// writeicon(whandle[CROSS],5,savestring);
 strcpy(savestring,temp);
}





os_error * addusersquaresolution(void)
{
 os_error * err;
 char     * p;

 err=iconaddr(buttonshandle,IDC_BUTTONS_EDITW,&p);
 if(!err)
 {
  solwidth=1;
  solxwidth=(16+1)*solncharwidth;
  solheight=solnextheight;

  addsquaresolution(-1,-1,-1,-1,p);
  strcpy(savestring,p);
  writeicon(buttonshandle,IDC_BUTTONS_EDITW,"");
  opensol();
  setsolextent();
  refreshsols();
 }

 return(err);
}





void delsquaresolution(int n)
{
 char * p;

 if(n<nsol)
 {
  p=sbuffer+n*sizeof(wrdstr);
  memmove(p,p+sizeof(wrdstr),(nsol-n-1)*sizeof(wrdstr));
  nsol--;
 }
}




int wrdcmp(const void * p1,const void * p2)
{
 return(cstrcmp(((wrdstr*)p1)->text,((wrdstr*)p2)->text));
}


void sortsquaresolutions(void)
{
 wrdstr * w;

 if(nsol)
 {
  w=(wrdstr*)(sbuffer);
  qsort(w,nsol,sizeof(wrdstr),wrdcmp);
 }
}



int nselectedsquare(void)
{
 wrdstr * w;
 int      i;
 int      n;

 n=0;

 if(nsol)
 {
  w=(wrdstr*)(sbuffer);
  for(i=0;i<nsol;i++)
  {
   if(w->selected) n++;
   w++;
  }
 }

 return(n);
}


void clearsquaresolnscoords(void)
{
 wrdstr * w;
 int      i;

 if(nsol)
 {
  w=(wrdstr*)(sbuffer);
  for(i=0;i<nsol;i++)
  {
   w->x=w->y=w->dx=w->dy=-1;
   w++;
  }
 }
}




os_error * delselection(void)
{
 wrdstr * w;
 int      i;
 int      hit;

 hit=0;
 gridstartredraw();

 if(nsol)
 {
  for(i=0;i<nsol;i++)
  {
   w=(wrdstr*)(sbuffer+i*sizeof(wrdstr));

   if(w->selected)
   {
    gridaddredraw(w);
    gridclrword(w);
    delsquaresolution(i);
    hit=1;
    i--;
   }
  }
 }

 gridendredraw();

 if(hit)
 {
  opensol();
  setsolextent();
  refreshsols();
 }

 return(NULL);
}








void gridgetstring(int clue,char * string)
{
 int    x;
 int    y;
 int    len;

 len=cluestr[clue].len;
 x=cluestr[clue].x;
 y=cluestr[clue].y;

 if(cluestr[clue].down)
 {
  while(len--) *string++=griddata[x][y++];
 }
 else
 {
  while(len--) *string++=griddata[x++][y];
 }

 *string=0;
}





void fillinstring(int clue,char * p)
{
 int    x;
 int    y;
 int    len;

 len=cluestr[clue].len;
 x=cluestr[clue].x;
 y=cluestr[clue].y;

 if(cluestr[clue].down)
 {
  while(len--)
  {
   while(*p==' ') p++;
   griddata[x][y++]=(char)gridcasechar(*p++);
   if(!*p) break;
  }
 }
 else
 {
  while(len--)
  {
   while(*p==' ') p++;
   griddata[x++][y]=(char)gridcasechar(*p++);
   if(!*p) break;
  }
 }
}




/* copies the s'th solution into the grid */

static void writesolution(int s)
{
 int    n;
 char * p;

 for(n=0;n<solwidth;n++)
 {
  p=swordn(*((int*)(sbuffer+(s*solwidth+n)*sizeof(int))));
  fillinstring(n,p);
  modfile();
 }

 refresh_zone();
}



/* problem is to scan zone area, and block it out into clues */
/* xc0<xc1, yc1<yc0, inclusive coords                        */


static void setupclues(void)
{
 int xc0;
 int yc0;
 int xc1;
 int yc1;
 int i;
 int j;
 int x;
 int y;
 int finished;

 if(zx0==-1) return;

 if(zx0<zx1)
 {
  xc0=zx0;
  xc1=zx1;
 }
 else
 {
  xc0=zx1;
  xc1=zx0;
 }

 if(zy0>zy1)
 {
  yc0=zy0;
  yc1=zy1;
 }
 else
 {
  yc0=zy1;
  yc1=zy0;
 }

 cluex0=xc0;
 cluex1=xc1;
 cluey0=yc0;
 cluey1=yc1;


 solwidth=0;

 for(x=xc0;x<=xc1;x++)
 {
  for(y=yc1;y<=yc0;y++)
  {
   if((gridstate[x][y] & STMASK)!=HILITE)
   {
    gridstate[x][y]|=(XMASK+YMASK);
   }
   else
   {
    gridstate[x][y]&=~(XMASK+YMASK);
   }
  }
 }

 for(y=yc1;y<=yc0;y++)
 {
  for(x=xc0;x<=xc1;x++)
  {
   if((gridstate[x][y] & (XMASK |YMASK))!=(XMASK |YMASK))
   {
    if((!(gridstate[x][y] & XMASK)) && 
       (x<(xc1)) && 
       (!(gridstate[x+1][y] & XMASK)) &&
       (!(gridstate[x+1][y] & BLOCKX)))
    {                                       /* x clue */
     cluestr[solwidth].x=x;
     cluestr[solwidth].y=y;
     cluestr[solwidth].down=0;
     j=0;

     for(i=x;i<=xc1;i++) 
     {
      finished=(gridstate[i][y] & XMASK);
      gridstate[i][y]|=XMASK;
      if(finished) break;
      j++;
      if(i<xc1 && (gridstate[i+1][y] & BLOCKX)) break;
     }

     cluestr[solwidth].len=(char)j;

     solwidth++;
    }


    if((!(gridstate[x][y] & YMASK)) && 
       (y<(yc0)) && 
       (!(gridstate[x][y+1] & YMASK)) &&
       (!(gridstate[x][y+1] & BLOCKY)))
    {                                      /* y clue */
     cluestr[solwidth].x=x;
     cluestr[solwidth].y=y;
     cluestr[solwidth].down=1;
     j=0;

     for(i=y;i<=yc0;i++)
     {
      finished=(gridstate[x][i] & YMASK);
      gridstate[x][i]|=YMASK;
      if(finished) break;
      j++;
      if(i<yc0 && (gridstate[x][i+1] & BLOCKY)) break;
     }

     cluestr[solwidth].len=(char)j;

     solwidth++;
    }
   }
   if(solwidth>=MAXCLUE) break;
  }
  if(solwidth>=MAXCLUE) break;
 }

 solxwidth=(xc1-xc0+1)*solncharwidth;

 if(solwidth<=1)
 {
  solheight=solnextheight;
 }
 else
 {
  solheight=(yc0-yc1+1)*solnintheight+solnintheight;
 }
}



int nextclue(char * string,int clue)
{
 int i;
 int j;
 int x;
 int y;

 for(x=0;x<maxx;x++)
  for(y=0;y<maxy;y++)
   if((gridstate[x][y] & STMASK)==BLOCK)
   {
    gridstate[x][y]|=(XMASK+YMASK);
   }
   else
   {
    gridstate[x][y]&=~(XMASK+YMASK);
   }


 for(y=0;y<maxy;y++)
 {
  for(x=0;x<maxx;x++)
  {
   if((gridstate[x][y] & STMASK)!=BLOCK)
   {
    if(((!(gridstate[x][y] & XMASK)) && 
        (x<(maxx-1)) && 
        (!(gridstate[x+1][y] & (XMASK|BLOCKX)))))
    {                                       /* x clue */
     j=0;

     for(i=x;i<maxx;i++) 
     {
      if((gridstate[i][y] & BLOCKX) && i!=x) break;
      if((gridstate[i][y] & STMASK)==BLOCK) break;
      gridstate[i][y]|=XMASK;
      string[j++]=griddata[i][y];
     }

     string[j]=0;

     if(!clue--) return(1);
    }


    if(((!(gridstate[x][y] & YMASK)) && 
        (y<(maxy-1)) && 
        (!(gridstate[x][y+1] & (YMASK|BLOCKY)))))
    {                                      /* y clue */
     j=0;

     for(i=y;i<maxy;i++)
     {
      if((gridstate[x][i] & BLOCKY) && i!=y) break;
      if((gridstate[x][i] & STMASK)==BLOCK) break;
      gridstate[x][i]|=YMASK;
      string[j++]=griddata[x][i];
     }

     string[j]=0; 

     if(!clue--) return(1);
    }
   }
  }
 }

 return(0);
}




os_error * updatesolutions(void)
{

 setupclues();
 setsolextent();
 refreshsols();

 return(NULL);
}



void blanksolutions(void)
{
 if(nsol)
 {
  clearsolutions(); 
  opensol();
  setsolextent();
  refreshsols();
 }
}


static void szero(int userhandle)
{
 USE(userhandle);
}


static void scallback(int userhandle)
{
 buttonssolve(1);
 addzeroevent(szero,0);
 search(0);
 remzeroevent(szero,0);
 buttonssolve(0);

 opensol();
 setsolextent();
 refreshsols();

 USE(userhandle);
}



static char anagramstring[STRLEN];



static void scallbacka(int userhandle)
{
 buttonssolve(1);
 addzeroevent(szero,0);
 anagramsearch(anagramstring);
 remzeroevent(szero,0);
 buttonssolve(0);

 opensol();
 setsolextent();
 refreshsols();

 USE(userhandle);
}





/* for each square which has a character in */
/* move in the 8 directions                 */

static void solve(int sx,int sy,int dx,int dy)
{
 char currentword[STRLEN];
 int c;
 int i;
 int n;
 int x;
 int y;

 x=sx;
 y=sy;

 n=0;

 while(x<maxx && y<maxy && x>=0 && y>=0)
 {
  if((gridstate[x][y] & STMASK)==CHARST)
  {
   c=tolower(griddata[x][y]);
   if(c>='a' && c<='z')
   {
    currentword[n++]=(char)c;
    if(n>=(STRLEN-1)) break;
   }
   else break;
  }
  else break;

  x+=dx;
  y+=dy;
 }


 /* now got a word */

 for(i=n;i>=minsollen;i--)
 {
  currentword[i]=0;
  if(wordsearch(currentword))
  {
   addsquaresolution(sx,sy,dx,dy,currentword);
   break;
  }
 }
}



static void scallbacksolvesq(int userhandle)
{
 int        x;
 int        y;
 int        dx;
 int        dy;

 buttonssolve(1);
 addzeroevent(szero,0);
 hourglasson();

 for(x=0;x<maxx;x++)
 {
  for(y=0;y<maxy;y++)
  {
   for(dx=-1;dx<=1;dx+=1)
   {
    for(dy=-1;dy<=1;dy+=1)
    {
     if(dx || dy) solve(x,y,dx,dy);
    }
   }

   if(buttonsevent()) break;
   poll();
  }
  if(y<maxy) break;
 }

 cprintf("solve1");

 hourglassoff();
 remzeroevent(szero,0);
 buttonssolve(0);

 clrgridcnt();

 cprintf("solve2");

 sortsquaresolutions();
 opensol();
 setsolextent();
 refreshsols();


 USE(userhandle);
}




os_error * solvesquare(void)
{
 os_error * err;

 err=checkfiledc();
 if(!err)
 {
  clearsolutions();

  solwidth=1;                /* number of  words per solution */

  solxwidth=(16+1)*solncharwidth;
  solheight=solnextheight;

  addscheduledevent(scallbacksolvesq,0,10);

  opensol();
  setsolextent();
  refreshsols();
 }
 return(NULL);
}













os_error * solution(void)
{
 os_error * err;

 err=NULL;
 
 err=checkfiledc();
	if(!err)
 {
  calczonesize();


  if(zx0==-1)
  {
   err=geterror(ENMW); // Need marked word!
  }

  if(!err)
  {
   clearsolutions();
   setupclues();

   if(solwidth)
   {
    addscheduledevent(scallback,0,10);
// search(0);
   }
   else
   {
    err=geterror(ENTS);  // Nothing to solve!
   }

   opensol();
   setsolextent();
   refreshsols();
  }
 }

 return(err);
}






os_error * anagram(void)
{
 os_error * err;
 char     * p;
 char       string[STRLEN];
 int        alen;
 int        len;
 int        i;

 err=NULL;
 
 err=checkfiledc();
 if(!err)
 {
  calczonesize();
 
  if(zx0==-1)
  {
   err=geterror(ENMW);  // Need marked word!
  }

  if(!err)
  {
   clearsolutions();
   setupclues();

   if(solwidth!=1)
   {
    err=geterror(EASW); // An anagram must be a single marked word!
   }
   else
   {
    err=iconaddr(buttonshandle,IDC_BUTTONS_EDIT,&p);
    if(!err)
    {
     strcpy(anagramstring,p);
     alen=strlen(anagramstring);

     gridgetstring(0,string);
     len=strlen(string);

     if(alen==0)
     {
      for(i=0;i<len;i++) 
      {
       if(string[i]==32)
       {
        err=geterror(EASP); // Can't have space in anagram
        break;
       }
      }
      strcpy(anagramstring,string);
     }
     else
     if(alen!=len)
     {
      err=geterror(EAMAT);
     }

     if(!err) addscheduledevent(scallbacka,0,10);
    }
   }

   opensol();
   setsolextent();
   refreshsols();
  }
 }

 return(err);
}






os_error * solninit(int mainhandle)
{
 os_error * err;

 err=err=createwindowparent(TSOLN,&solnhandle,mainhandle);
 if(!err)
 {
  wimp_setwindowbackground(solnhandle,CCRGB|PALWHITE);
  wimp_setwindowflags(solnhandle,WINDOWFIXED,0);
  addredrawevent(solnredraw,solnhandle,0);
  addclickevent(solnclick,solnhandle,0);
  adddataload(solnhandle,0,loadgridv);
  adddataloadpost(solnhandle,0,loadgridpostv);
  adddataloadtype(solnhandle,0,loadgridtypev);

  setsolextent();
 }


 return(err);
}